Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  StdCtrls;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    ListView1: TListView;
    Procedure Button1Click(Sender: TObject);
    Procedure ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; Var Compare: Integer);
  private
    { private declarations }
  public
    { public declarations }
  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }

Procedure TForm1.Button1Click(Sender: TObject);
  Procedure Add(b: Boolean; s1, s2: String);
  Var
    li: TListItem;
  Begin
    li := ListView1.items.add;
    li.Checked := b;
    li.SubItems.Add(s1);
    li.SubItems.Add(s2);
  End;
Begin
  add(true, 'a', 'j');
  add(false, 'b', 'i');
  add(true, 'c', 'h');
  add(false, 'd', 'g');
  add(true, 'e', 'f');
  button1.enabled := false;
End;

Procedure TForm1.ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; Var Compare: Integer);
Begin
  If ListView1.SortColumn = 0 Then Begin
    Compare := ord(item1.Checked) - ord(item2.Checked);
  End
  Else Begin
    Compare := CompareStr(item1.SubItems[ListView1.SortColumn - 1], item2.SubItems[ListView1.SortColumn - 1]);
  End;
  //If ListView1.SortDirection = sdDescending Then Begin
  If CheckBox1.Checked Then Begin
    compare := -Compare;
  End;
End;

End.

